TT = {}
local TT = TT

TT.NAME = "ThievingTimer"
TT.REFIRE = "TT_REFIRE_UPDATE"
TT.currentScene = ""

TT.Defaults = {}
TT.Defaults.ui = {
    ["offsetY"]  = 177.93,
    ["offsetX"]  = -215.115,
    ["point"]    = TOPLEFT,
    ["relPoint"] = TOPLEFT,
}

TT.Defaults.ui_stat = {
    ["offsetX"]  = -138.53,
    ["offsetY"]  = 367.96,
    ["point"]    = TOPLEFT,
    ["relPoint"] = TOPLEFT,
}

TT.hide    = false

function TT:UpdateTimer()
    EVENT_MANAGER:UnregisterForUpdate(TT.REFIRE)

    if not TT.hide then
        EVENT_MANAGER:RegisterForUpdate(TT.REFIRE, 1000, TT.UpdateTimer)
    end

    local totalSells, sellsUsed, resetTimeSeconds = GetFenceSellTransactionInfo()

    -- 60 * 60 * 24
    if resetTimeSeconds > 86400 then
        resetTimeSeconds = 0;
    end

    local timetext, _ = FormatTimeSeconds(resetTimeSeconds, TIME_FORMAT_STYLE_COLONS, TIME_FORMAT_PRECISION_SECONDS, TIME_FORMAT_DIRECTION_NONE)
    timetext = tostring(timetext)
    timetext = "|c00ff44" .. timetext .. "|r"
    TT_Time_Fence_Label:SetText(timetext)
end

function TT:TooltipHandle(control, show)
    if show then
        control:SetHandler("OnMouseEnter", ZO_Options_OnMouseEnter)
        control:SetHandler("OnMouseExit", ZO_Options_OnMouseExit)
    else
        control:SetHandler("OnMouseEnter", function() return end)
        control:SetHandler("OnMouseExit", function() return end)
    end
end

function TT:Scenes()
    local scenes = { "gamepad_stats_root", "stats", "fence_keyboard", "gamepad_store" }

    for _, scene in ipairs(scenes) do
        local sceneObj = SCENE_MANAGER:GetScene(scene)
        sceneObj:RegisterCallback("StateChange", function(oldState, newState)
            -- d ( scene .. " :: " .. tostring(oldState) .. " -> " .. tostring(newState) )
            -- if scene == gamepad_store and gg

            TT.currentScene = scene;
            TT.hide = not ( newState and ( newState == "showing" or newState == "shown" ) )
            TT_Window:SetHidden(TT.hide)

            TT_Time:SetHidden(TT.hide)

            TT_Window:ClearAnchors()
            if TT.currentScene == "stats" or TT.currentScene == "gamepad_stats_root" then
                TT_Window:SetAnchor(TT.sv.ui_stat.point, GuiRoot, TT.sv.ui_stat.relPoint, TT.sv.ui_stat.offsetX, TT.sv.ui_stat.offsetY)
            else
                TT_Window:SetAnchor(TT.sv.ui.point, GuiRoot, TT.sv.ui.relPoint, TT.sv.ui.offsetX, TT.sv.ui.offsetY)
            end

            TT:TooltipHandle(TT_Time, not TT.hide)
            TT:UpdateTimer()
        end)
    end
end

function TT:UI()
    TT_Time.data = { tooltipText = "This is the countdown until your |c00ff44Fencing|r and |cff44ffLaundering|r will reset."}
    TT_Window:SetHandler("OnMoveStop", function (self)
        local valid, point, _, relPoint, offsetX, offsetY = self:GetAnchor(0)
        if valid then
            if TT.currentScene == "stats" or TT.currentScene == "gamepad_stats_root" then
                TT.sv.ui_stat.offsetX  = offsetX
                TT.sv.ui_stat.offsetY  = offsetY
                TT.sv.ui_stat.point    = point
                TT.sv.ui_stat.relPoint = relPoint
            else
                TT.sv.ui.offsetX  = offsetX
                TT.sv.ui.offsetY  = offsetY
                TT.sv.ui.point    = point
                TT.sv.ui.relPoint = relPoint
            end
        end
    end)
end

function TT:Init()
    TT.sv = ZO_SavedVars:New("TT_sv", 1, nil, TT.Defaults)

    TT:Scenes()
    TT:UI()
end


EVENT_MANAGER:RegisterForEvent(TT.NAME, EVENT_ADD_ON_LOADED, function (event, addonName)
    if addonName == TT.NAME then
        TT:Init()
    end
end)
